//====================================================== file = outport.c =====
//=  Output port for IYER PPS (centralized) switch simulation model           =
//=============================================================================
//=  Contains: outport()                                                      =
//=============================================================================
//=  Notes:  1) Internal switch planes are modeled as FCFS-OQ                 =
//=---------------------------------------------------------------------------=
//=  History: AAS (04/01/03) - Genesis                                        =
//=============================================================================
#define EXTERNAL        // This is an external file (used in common.h)

//----- Include files ---------------------------------------------------------
#include <math.h>       // Needed for ceil()
#include "csim.h"       // Needed for CSIM
#include "common.h"     // Needed for common stuff

void outport(int from_id,int out_id,int channel_num,int tag,double org_time)
{

  create("outport");

  // Sending sequence # of cell to mux_sel()
  send(Seq_number[channel_num][out_id], (long)tag);

  // Queueing cell at internal outport links
  queue(Q_event[channel_num][out_id]);

  // Transmitting the cell
  reserve(Outport_internal[channel_num][out_id]);
  hold(ceil(K/S)*CELL_TIME);
  release(Outport_internal[channel_num][out_id]);

  // Forward cell to the outport multiplexor
  extmux[out_id](from_id,out_id,tag,org_time);
  return;
}
